/*** COPYRIGHT SECTION ******************************************************
 *  display.h
 *
 *  Control the display on standard output according to differents options
 *  given by user.
 *  for Wireshark - Network traffic analyzer
 *
 *  Copyright (c) 2007 by KONTRON Canada Inc.
 *  chanthy.toeung@ca.kontron.com
 *
 *  Wireshark - Network traffic analyzer
 *  By Gerald Combs <gerald@wireshark.org>
 *  Copyright 1999 Gerald Combs
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.

 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation,
 *  Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef DISPLAY_H
#define DISPLAY_H
/*=========================================================================
* INCLUDES
*=========================================================================*/
/*=========================================================================
* CONSTANTS
*=========================================================================*/
#define DEBUG_DEFAULT         0
#define DEBUG_LEVEL_RAW       1
#define DEBUG_LEVEL_PACKET    2
#define DEBUG_LEVEL_ALL       3
#define TRUE                  1
#define FALSE                 0
/*=========================================================================
* TYPEDEFS
*=========================================================================*/
/*=========================================================================
| GENERAL TYPE DEFINITIONS
========================================================================*/
static int debug;
static int quiet;
static int normalProcess;
static int withOption;

/*=========================================================================
| GENERAL TYPE DEFINITIONS
 ========================================================================*/

/*=========================================================================
* FUNCTIONS
*=========================================================================*/

void usage (
);

int get_option(
   int argc,
   char* argv[]
);

int get_debug_level();

int get_quiet_option();

int get_opt();

#endif
