/*** COPYRIGHT SECTION ******************************************************
 *  readfile.c
 *
 *  Contain mutiple function to read ipmb data binary file and display in humain
 *  readable format.
 *  for Wireshark - Network traffic analyzer
 *
 *  Copyright (c) 2007 by KONTRON Canada Inc.
 *  chanthy.toeung@ca.kontron.com
 *
 *  Wireshark - Network traffic analyzer
 *  By Gerald Combs <gerald@wireshark.org>
 *  Copyright 1999 Gerald Combs
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.

 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation,
 *  Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
/*=========================================================================
* INCLUDES
*=========================================================================*/
#include <sys/time.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "bg_ipmipacket.h"

/*=========================================================================
* CONSTANTS
*=========================================================================*/

/*=========================================================================
* TYPEDEFS
*=========================================================================*/

/*=========================================================================
* MAIN PROGRAM
* complie by : readfile      pFileName
*=========================================================================*/
int main ( int argc, char *argv[] ) {
   char* pFileName;
   FILE* pFileRead;
   int i, l;
   struct timeval res;
   time_t curtime;
   char buffer[30];

   if ( argc<2 ){
      printf( "***Please specify the file name to be read.\n" );
      printf( "***usage : readfile FileName ... \n" );
   }
   else{
	  int count;
      pFileName = argv[1];
      printf( "%s\n", pFileName );
      pFileRead = fopen( pFileName, "r" );
      /** try to read the data from file */
      if ( pFileRead == NULL ){
         printf( "error can't open the reading file\n" );
      }      
      else{
         printf( "start reading\n" );
		   u16 dataRead[64];
		   int pk = 0;
         if( strcmp( pFileName, "rawData" ) == 0  ){
            while( !feof( pFileRead ) ){
               i = fread( &res, sizeof( res ), 1, pFileRead );
               curtime = res.tv_sec;            
               strftime( buffer, 30, "%m-%d-%y   %T.", localtime( &curtime ) );
               printf( "%s%ld", buffer, res.tv_usec );         
			   i = fread( &count, sizeof( count ), 1, pFileRead );
               i = fread( &dataRead, (size_t)(count*sizeof(u16)), 1, pFileRead );

               printf( "  [S]" );
               for ( l = 0; l < count; l++ ){
                  printf( "  %02x", dataRead[l] );
               }
               printf( "  [P]\n" );
               if( i != 0 )
                  pk++;
            }
            printf("pk = %d\n", pk);
         }
         else{
            tIpmb_Header   rqIpmbHeader;
            tIpmbPacket    rqPaquet;
            int pk = 0;
            while( !feof( pFileRead ) ){
               i = fread( &rqIpmbHeader, sizeof( rqIpmbHeader ), 1, pFileRead );
               i = fread( &rqPaquet, sizeof( rqPaquet ), 1, pFileRead );
               pk++;
               printf(" pk = %d\n", pk);
              
               if ( ftell( pFileRead ) == 8192 )
                  printf("ftell = 8k\n");
               curtime = rqPaquet.waitTime.tv_sec;            
               strftime( buffer, 30, "%m-%d-%y   %T.", localtime( &curtime ) );
               printf( "%s%f", buffer, rqPaquet.waitTime.tv_usec/1000000.0 );             
               printf( "   [S]" );
               printf( "  %02x  %02x  %02x  %02x || ", rqIpmbHeader.SlaveAdd,
                       rqIpmbHeader.netFn, rqIpmbHeader.LUN,
                       rqIpmbHeader.checkSum );
               printf( "  %02x  %02x  %02x  %02x \n data = ", rqPaquet.SlaveAdd,
                       rqPaquet.rqSeq, rqPaquet.LUN, rqPaquet.cmd );
               for ( l = 0; l< rqPaquet.data[0]-5; l++ ){
                  printf( "  %02x", rqPaquet.data[l] );
               }
               printf( "  \n\n" );
            }
         }
		   printf(":D");
         printf( "DONE\n" );
         fclose( pFileRead );
      }
	}
   return 0;
}
